﻿using System;

namespace UMK.WzorceStrukturalne
{
    class Znak
    {
        //stan wewnętrzny
        protected char litera;        

        public Znak(char litera)
        {
            this.litera = litera;
        }

        public void Wyświetl(ConsoleColor kolor)
        {
            ConsoleColor oryginalnyKolor = Console.ForegroundColor;
            Console.ForegroundColor = kolor;
            Console.Write(litera);
            Console.ForegroundColor = oryginalnyKolor;
        }
    }

    class ZnakA : Znak
    {
        public ZnakA()
            :base('A')
            {
            }
    }

    class ZnakB : Znak
    {
        public ZnakB()
            : base('B')
        {
        }
    }

    class ZnakD : Znak
    {
        public ZnakD()
            : base('D')
        {
        }
    }

    class ZnakU : Znak
    {
        public ZnakU()
            : base('U')
        {
        }
    }

    class ZnakNierozpoznany : Znak
    {
        public ZnakNierozpoznany()
            : base('?')
        {
        }
    }

    //Fabryka abstrakcyjna z buforem obiektów
    class FabrykaZnaków
    {
        private Dictionary<char, Znak> bufor = new Dictionary<char, Znak>();

        public Znak PobierzZnak(char litera)
        {
            Znak znak;
            if (bufor.Keys.Contains(litera)) znak = bufor[litera];
            else
            {
                switch (litera)
                {
                    case 'A': znak = new ZnakA(); break;
                    case 'B': znak = new ZnakB(); break;
                    case 'D': znak = new ZnakD(); break;
                    case 'U': znak = new ZnakU(); break;
                    default: znak = new ZnakNierozpoznany(); break;
                }
                bufor.Add(litera, znak);
            }
            return new Znak(litera);
        }
    }

    //zadanie domowe: wywalić klasy potomne
    //zadanie domowe: fabrykę zrobić singleton
}